Subject: bug#55441: [cuirass] hang in "In progress..."; runs out of pgsql connections

From: Mathieu Othacehe <[email-masked]>
Date: Mon, 16 May 2022 09:32:43 +0200

Hello Maxim,

Thanks for the report, the root cause here is the evaluation
hanging. The Postgres slots starvation is just a symptom caused by
having many concurrent (stuck) evaluation processes using slots.

I noticed this error: https://ci.guix.gnu.org/eval/320682/log/raw.

The following lines can be caused by having a multi-threaded program:
(cuirass scripts evaluate) because of its par-for-each procedure, call
"primitive-fork" in open-bidirectional-pipe of (guix inferior).

--8<---------------cut here---------------start------------->8---
warning: call to primitive-fork while multiple threads are running;
         further behavior unspecified.  See "Processes" in the
         manual, for more information.
--8<---------------cut here---------------end--------------->8---

Not sure that it could cause the observed hang, Ludo what do you think?

Thanks,

Mathieu